math.randomseed(os.time())

-- Air Warriors - v0.5 01/08/2006 
-- by J. Haasl (k_man316)
-- enjoy!

titleMusic = Sound.load("sounds/warriors.wav")
titleMusic:play()

-- Load Sprites
titleScreen	= Image.load("images/title_screen.png")
enemy1		= Image.load("images/enemy1.png")
enemy2 		= Image.load("images/enemy2.png")
enemy2DL 	= Image.load("images/enemy2_down_left.png")
enemy2DR	= Image.load("images/enemy2_down_right.png")
enemy2L		= Image.load("images/enemy2-left.png")
enemy2R		= Image.load("images/enemy2-right.png")
bomber		= Image.load("images/bomber.png")
a10Img 		= Image.load("images/a10.png")
a10Bright	= Image.load("images/a10bright.png")
a10Dark		= Image.load("images/a10.png")
stealthImg	= Image.load("images/stealth.png")
stealthBright 	= Image.load("images/stealthbright.png")
stealthDark	= Image.load("images/stealth.png")
planeShoot	= Image.load("images/single_shot.png")
a10Shoot	= Image.load("images/double_shot.png")
planeSmall	= Image.load("images/plane_small.png")
a10Select	= Image.load("images/a10_select.png")
stealthSelect	= Image.load("images/stealth_select.png")
a10Select	= Image.load("images/a10_select.png")
selectBox	= Image.load("images/select_box.png")
selectBox1	= Image.load("images/select_box1.png")
airTitleWording = Image.load("images/air_warriors_title.png")
selectBg	= Image.load("images/selectBg.png")
smallBang 	= Image.load("images/small_bang.png")
bigBang1	= Image.load("images/big_bang1.png")
bigBang1A	= Image.load("images/big_Bang1a.png")
bigBang2	= Image.load("images/big_bang2.png")
bigBang3	= Image.load("images/big_bang3.png")
bang1		= Image.load("images/bang1.png")
bang2		= Image.load("images/bang2.png")
bang3		= Image.load("images/bang3.png")
bang4		= Image.load("images/bang4.png")
bang5		= Image.load("images/bang5.png")
bang6		= Image.load("images/bang6.png")
bang7		= Image.load("images/bang7.png")
bang8		= Image.load("images/bang8.png")
bang9		= Image.load("images/bang9.png")
bang10		= Image.load("images/bang10.png")
bang11		= Image.load("images/bang11.png")
bang12		= Image.load("images/bang12.png")
bang13		= Image.load("images/bang13.png")
bang14		= Image.load("images/bang14.png")

wordingBG	= Image.load("images/wording_bg.png")
smokeSmall	= Image.load("images/smoke2.png")
smokeMedium	= Image.load("images/smoke.png")
streak		= Image.load("images/streak.png")


showTitle 	= 1
showPlaneSelect = 1
planeUsed	= " "
enemyActive     = 1
highScore       = 0
planeWidth	= 0
planeHeight	= 0
gameCounter     = 0
score 		= 0
a10Speed	= 2
stealthSpeed  	= 5
planeSpeed	= 0
backgroundY 	= 0
bgIndex 	= 1
nextBGIndex	= 2
bgUp		= 1
planeShootActive = 0
fireX		= 0
fireY    	= 0
playerLives     = 3
selectLeft	= 1
titleUp 	= 300
selectColor	= 1
shotsFired	= 0
planesHit	= 0
totalEnemies	= 0

planeReset	= 1
resetCount 	= 1


gamePlaying	= 1
gameOver        = 0

t1EnemyXstart 	= 150
t1EnemyYstart	= -240

t2EnemyXstart 	= 70
t2EnemyYstart	= -400

bomberXstart	= 240
bomberYstart	= -150


level           = 1
levelLoop	= 0
levelChangeNum	= 8


t1Enemys	= {}
t1EnemysActive 	= 0
t1CreateActive 	= 0
t1EnemysSpeed  	= 1.2

bomberActive 	= 0
bomberCreateActive = 0
bomberSpeed 	= .4
bomberHits	= 45
bomberX		= 0
bomberY		= 0
bomberDirection = "LEFT"
t1Wave		= 1
t2Wave		= 1
maxT1Wave	= 20
maxT2Wave	= 25

t2Enemys = {}
t2CreateActive  = 0
t2EnemysActive  = 0
t2EnemysSpeed   = 1.8
t2EnemysDir	= "DOWN"

enemyFire = {}
explosions = {}
maxExplosions = 10

maxPlayerFireA = 10
maxFireAdelay 	 = 10
playerFireAdelay = 10
playerFireA	= {}

for i = 1, maxPlayerFireA do
	playerFireA[i] = {}
	playerFireA[i].xaxis = 0
	playerFireA[i].yaxis = 0
	playerFireA[i].state = 0 
	playerFireA[i].justFired = 1
end

maxPlayerFireB 	= 10
maxFireBdelay 	= 20
playerFireB	= {}
playerFireBdelay = 20


for i = 1, maxPlayerFireB do
	playerFireB[i] = {}
	playerFireB[i].xaxis = 0
	playerFireB[i].yaxis = 0
	playerFireB[i].state = 0 
	playerFireB[i].justFired = 0

end




for i = 1, maxExplosions do

	explosions[i] = {}
	explosions[i].xaxis = 0
	explosions[i].yaxis = 0
	explosions[i].loop  = 0
	explosions[i].state = 0 

end

-- Load Sound Effects

allSys 	= Sound.load("sounds/all_systems.wav")
fireSnd = Sound.load("sounds/missle.wav") 
bang	= Sound.load("sounds/explosion_fast.wav")
enemyWarn = Sound.load("sounds/siren1.wav")
titleMusic = Sound.load("sounds/warriors.wav")

-- Player plane coordinates
px = 230
py = 220

-- enemy plane coordinates

ex = 240
ey = -180

-- Color constants
white = Color.new(255, 255, 255)
green = Color.new(0, 255, 0)
red   = Color.new(255, 0, 0)

function titleShow()

	while showTitle == 1 do

		while titleUp > 20 do
			screen:blit(0, 0, titleScreen)
			screen:blit(40, titleUp, airTitleWording)
			titleUp = titleUp - 2
			screen.waitVblankStart()
			screen:flip()

		end
			
		screen:blit(0, 0, titleScreen)
		screen:blit(40, titleUp, airTitleWording)
		screen:print(160,120, "P R E S S  S T A R T", white)
		screen:print(375,260, "by k_man316", white)

		pad = Controls.read()

		if pad:start() then
			showTitle = 0
		end		

		screen.waitVblankStart()
		screen:flip()
	end
end

function selectShow()

	while showPlaneSelect == 1 do

		screen:clear()
		screen:blit(0, 0, selectBg)
		screen:print(148, 10, "P L A Y E R  S E L E C T", white)
		screen:blit(20, 150, wordingBG)

		if selectLeft == 1 then
			screen:print(30, 170, "WARTHOG", red)
			screen:print(30, 190, "The A10 Warthog packs more powerful weapons, but", white)
			screen:print(30, 200, "lacks the speed and agility of it's smaller Stealth", white) 
			screen:print(30, 210, "counterpart", white) 

			if selectColor < 5 then
				screen:blit(65, 15, selectBox)
			elseif selectColor < 10 then
				screen:blit(65, 15, selectBox1)
			end
		elseif selectLeft == 0 then
			screen:print(30, 170, "STEALTH FIGHTER", red)
			screen:print(30, 190, "Lighter and more nimble than the Warthog, this", white)
			screen:print(30, 200, "small fighter moves at a swifter pace than the A-10.", white) 
			screen:print(30, 210, "This swift speed means less firepower compared to", white) 
			screen:print(30, 220, "the Warthog", white) 


			if selectColor < 5 then
				screen:blit(265, 15, selectBox)
			elseif selectColor < 10 then
				screen:blit(265, 15, selectBox1)
			end
		end

		if selectColor == 10 then 
			selectColor = 0
		end

		selectColor = selectColor + 1
				
		screen:blit(70, 37, a10Select)
		screen:blit(270, 37, stealthSelect)
 		screen.waitVblankStart()
		screen:flip()


		pad = Controls.read()

		if pad:cross() then
			if selectLeft == 0 then
				planeUsed = "STEALTH"
				showPlaneSelect = 0
			elseif selectLeft == 1 then
				planeUsed = "A10"
				showPlaneSelect = 0
			end
		
			showPlaneSelect = 0
		end

		if pad:left() then
			selectLeft = 1
		end
		if pad:right() then
			selectLeft = 0
		end
	end
end


function addPlayerFireA(fireax, fireay)

	fireABlankFound = 0
	i = 1
	if playerFireAdelay == maxFireAdelay then
		while fireABlankFound == 0 do
			if playerFireA[i].state == 0 then
				fireSnd:play()
				playerFireA[i].xaxis = fireax
				playerFireA[i].yaxis = fireay
				playerFireA[i].state = 1
				fireABlankFound = 1
				playerFireAdelay = maxFireAdelay - 1
				fireSnd:play()
			end
			i = i + 1
		end
	elseif playerFireAdelay > 0 then
		playerFireAdelay = playerFireAdelay - 1
	elseif playerFireAdelay <= 0 then
		playerFireAdelay = maxFireAdelay
	end
end


function drawPlayerFireA()

	for i = 1, maxPlayerFireA do
		if playerFireA[i].state == 1 then
			playerFireA[i].yaxis = playerFireA[i].yaxis-7
			screen:blit(playerFireA[i].xaxis, playerFireA[i].yaxis, a10Shoot)
			if playerFireA[i].yaxis <= 0 then			
				playerFireA[i].state = 0
			end
		end
	end
end

function addPlayerFireB(firebx, fireby)

	fireBBlankFound = 0
	i = 1
	if playerFireBdelay == maxFireBdelay then
		while fireBBlankFound == 0 do
			if playerFireB[i].state == 0 then
				playerFireB[i].xaxis = firebx
				playerFireB[i].yaxis = fireby
				playerFireB[i].state = 1
				fireBBlankFound = 1
				playerFireBdelay = maxFireBdelay - 1
				fireSnd:play()
			end
			i = i + 1
		end
	elseif playerFireBdelay > 0 then
		playerFireBdelay = playerFireBdelay - 1
	elseif playerFireBdelay <= 0 then
		playerFireBdelay = maxFireBdelay
	end
end


function drawPlayerFireB()

	for i = 1, maxPlayerFireB do
		if playerFireB[i].state == 1 then
			playerFireB[i].yaxis = playerFireB[i].yaxis-7
			screen:blit(playerFireB[i].xaxis, playerFireB[i].yaxis, planeShoot)
			if playerFireB[i].yaxis < 0 then			
				playerFireB[i].state = 0
			end
		end
	end
end




function addExplosions(expx, expy)

	explosionBlankFound = 0
	i = 1

	while explosionBlankFound == 0 do
		if explosions[i].state == 0 then
			explosions[i].xaxis = expx
			explosions[i].yaxis = expy
			explosions[i].state = 1
			explosions[i].loop  = 1
			explosionBlankFound = 1
		end
		i = i + 1
	end
end


function drawExplosions()

	for i = 1, maxExplosions do
		if explosions[i].state == 1 then
			if explosions[i].loop ==1 then
				bang:play()
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang1)
			elseif explosions[i].loop == 2 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang2)
			elseif explosions[i].loop == 3 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang3)
			elseif explosions[i].loop == 4 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang4)
			elseif explosions[i].loop == 5 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang5)
			elseif explosions[i].loop == 6 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang6)
			elseif explosions[i].loop == 7 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang7)
			elseif explosions[i].loop == 8 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang8)
			elseif explosions[i].loop == 9 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang9)
			elseif explosions[i].loop == 10 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang10)
			elseif explosions[i].loop == 11 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang11)
			elseif explosions[i].loop == 12 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang12)
			elseif explosions[i].loop == 13 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang13)
			elseif explosions[i].loop == 14 then
				screen:blit(explosions[i].xaxis, explosions[i].yaxis, bang14)
				explosions[i].state = 0
			end
  			explosions[i].loop = explosions[i].loop + 1
		end
	end
end


function setT1StartCoord()

	t1EnemysCoord = {}

	for i = 1, maxT1Wave do
		t1EnemysCoord[i] = {}
	end

	
	t1EnemysCoord[1].xaxis = math.random(25, 455)
	t1EnemysCoord[1].yaxis = -330

	t1EnemysCoord[2].xaxis = math.random(25, 455)
	t1EnemysCoord[2].yaxis = -380

	t1EnemysCoord[3].xaxis = math.random(25, 455)
	t1EnemysCoord[3].yaxis = -230

	t1EnemysCoord[4].xaxis = math.random(25, 455)
	t1EnemysCoord[4].yaxis = -380

	t1EnemysCoord[5].xaxis = math.random(25, 455)
	t1EnemysCoord[5].yaxis = -330

	t1EnemysCoord[6].xaxis = math.random(25, 455)
	t1EnemysCoord[6].yaxis = -280

	t1EnemysCoord[7].xaxis = math.random(25, 455)
	t1EnemysCoord[7].yaxis = -100

	t1EnemysCoord[8].xaxis = math.random(25, 455)
	t1EnemysCoord[8].yaxis = -280

	t1EnemysCoord[9].xaxis = math.random(25, 455)
	t1EnemysCoord[9].yaxis = -30

	t1EnemysCoord[10].xaxis = math.random(25, 455)
	t1EnemysCoord[10].yaxis = -360

	t1EnemysCoord[11].xaxis =  math.random(25, 455)
	t1EnemysCoord[11].yaxis = -280

	t1EnemysCoord[12].xaxis = math.random(25, 455)
	t1EnemysCoord[12].yaxis = -200

	t1EnemysCoord[13].xaxis = math.random(25, 455)
	t1EnemysCoord[13].yaxis = -230

	t1EnemysCoord[14].xaxis = math.random(25, 455)
	t1EnemysCoord[14].yaxis = -60

	t1EnemysCoord[15].xaxis = math.random(25, 455)
	t1EnemysCoord[15].yaxis = -320

	t1EnemysCoord[16].xaxis = math.random(25, 455)
	t1EnemysCoord[16].yaxis = -50

	t1EnemysCoord[17].xaxis = math.random(25, 455)
	t1EnemysCoord[17].yaxis = -300

	t1EnemysCoord[18].xaxis = math.random(25, 455)
	t1EnemysCoord[18].yaxis = -10

	t1EnemysCoord[19].xaxis = math.random(25, 455)
	t1EnemysCoord[19].yaxis = -540

	t1EnemysCoord[20].xaxis = math.random(25, 455)
	t1EnemysCoord[20].yaxis = -100

end


function createBomber()

	if gameCounter == 7800 then
		enemyWarn:play()
	end
	if gameCounter == 8000 then
		bomberCreateActive = 1
	end

	if bomberCreateActive == 1 then
		bomberActive = 1
		bomberX = bomberXstart
		bomberY = bomberYstart
		totalEnemies = totalEnemies + 1
	end
	
	bomberCreateActive = 0
		
end



function createT1Enemys()

	if gameCounter == 0 then
		t1CreateActive = 1	
	elseif gameCounter == 500 then
		t1CreateActive = 1
	elseif gameCounter == 1100 then
		t1CreateActive = 1
	elseif gameCounter == 1900 then
		t1CreateActive = 1
	elseif gameCounter == 2500 then
		t1CreateActive = 1
	elseif gameCounter == 3200 then
		t1CreateActive = 1
	elseif gameCounter == 4000 then
		t1CreateActive = 1
	elseif gameCounter == 5100 then
		t1CreateActive = 1
	elseif gameCounter == 5800 then
		t1CreateActive = 1
	elseif gameCounter == 6900 then
		t1CreateActive = 1
	elseif gameCounter == 7400 then
		t1CreateActive = 1
	elseif gameCounter == 8000 then
		t1CreateActive = 1
	elseif gameCounter == 8400 then
		t1CreateActive = 1
	elseif gameCounter == 8900 then
		t1CreateActive = 1
	elseif gameCounter == 9200 then
		t1CreateActive = 1
	elseif gameCounter == 9600 then
		t1CreateActive = 1
	elseif gameCounter == 10000 then
		t1CreateActive = 1
	elseif gameCounter == 10400 then
		t1CreateActive = 1

	end

	if t1CreateActive == 1 then
		setT1StartCoord()	
		for i = 1, 5 do	
			t1Enemys[i] = {}
			t1Enemys[i].xaxis = t1EnemysCoord[t1Wave].xaxis
			t1Enemys[i].yaxis = t1EnemysCoord[t1Wave].yaxis
			t1Wave = t1Wave + 1
			t1Enemys[i].state = 1
			t1EnemyXstart = t1EnemyXstart + 50
			t1EnemyYstart = t1EnemyYstart + 40
			t1EnemysActive = 1
			totalEnemies = totalEnemies + 1
		end
		levelLoop = levelLoop + 1
	end

	if t1Wave >= maxT1Wave then
		t1Wave = 1
	end
	
	t1EnemyXstart = 150
	t1EnemyYstart = -240
	t1CreateActive = 0
end

function setT2StartCoord()

	t2EnemysCoord = {}

	for i = 1, maxT2Wave do
		t2EnemysCoord[i] = {}
	end

	t2EnemysCoord[1].xaxis = 120
	t2EnemysCoord[1].yaxis = -430
	t2EnemysCoord[1].turnDir = "HARDRIGHT" 
	t2EnemysCoord[1].turn	 = 200

	t2EnemysCoord[2].xaxis = 220
	t2EnemysCoord[2].yaxis = -380
	t2EnemysCoord[2].turnDir = "RIGHT" 
	t2EnemysCoord[2].turn	 = 100	

	t2EnemysCoord[3].xaxis = 280
	t2EnemysCoord[3].yaxis = -230
	t2EnemysCoord[3].turnDir = "LEFT" 
	t2EnemysCoord[3].turn	 = 25	

	t2EnemysCoord[4].xaxis = 340
	t2EnemysCoord[4].yaxis = -380
	t2EnemysCoord[4].turnDir = "HARDLEFT" 
	t2EnemysCoord[4].turn	 = 50	

	t2EnemysCoord[5].xaxis = 10
	t2EnemysCoord[5].yaxis = -330
	t2EnemysCoord[5].turnDir = "LEFT" 
	t2EnemysCoord[5].turn	 = 50	

	t2EnemysCoord[6].xaxis = 400
	t2EnemysCoord[6].yaxis = -80
	t2EnemysCoord[6].turnDir = "LEFT" 
	t2EnemysCoord[6].turn	 = 300

	t2EnemysCoord[7].xaxis = 350
	t2EnemysCoord[7].turnDir = "LEFT" 
	t2EnemysCoord[7].turn	 = 75	
	t2EnemysCoord[7].yaxis = -90

	t2EnemysCoord[8].xaxis = 300
	t2EnemysCoord[8].yaxis = -110
	t2EnemysCoord[8].turnDir = "HARDLEFT" 
	t2EnemysCoord[8].turn	 = 60	

	t2EnemysCoord[9].xaxis = 250
	t2EnemysCoord[9].turnDir = "LEFT" 
	t2EnemysCoord[9].turn	 = 50	
	t2EnemysCoord[9].yaxis = -130

	t2EnemysCoord[10].xaxis = 200
	t2EnemysCoord[10].yaxis = -150
	t2EnemysCoord[10].turnDir = "LEFT" 
	t2EnemysCoord[10].turn	 = 40	

	t2EnemysCoord[11].xaxis =  60
	t2EnemysCoord[11].yaxis = -280
	t2EnemysCoord[11].turnDir = "RIGHT" 
	t2EnemysCoord[11].turn	 = 10	

	t2EnemysCoord[12].xaxis = 75
	t2EnemysCoord[12].yaxis = -200
	t2EnemysCoord[12].turnDir = "RIGHT" 
	t2EnemysCoord[12].turn	 = 180	

	t2EnemysCoord[13].xaxis = 460
	t2EnemysCoord[13].yaxis = -230
	t2EnemysCoord[13].turnDir = "LEFT" 
	t2EnemysCoord[13].turn	 = 25	

	t2EnemysCoord[14].xaxis = 115
	t2EnemysCoord[14].yaxis = -60
	t2EnemysCoord[14].turnDir = "RIGHT" 
	t2EnemysCoord[14].turn	 = 50	

	t2EnemysCoord[15].xaxis = 310
	t2EnemysCoord[15].yaxis = -320
	t2EnemysCoord[15].turnDir = "LEFT" 
	t2EnemysCoord[15].turn	 = 65	

	t2EnemysCoord[16].xaxis = 420
	t2EnemysCoord[16].yaxis = -50
	t2EnemysCoord[16].turnDir = "LEFT" 
	t2EnemysCoord[16].turn	 = 1	

	t2EnemysCoord[17].xaxis = 290
	t2EnemysCoord[17].yaxis = -300
	t2EnemysCoord[17].turnDir = "LEFT" 
	t2EnemysCoord[17].turn	 = 300

	t2EnemysCoord[18].xaxis = 340
	t2EnemysCoord[18].yaxis = -10
	t2EnemysCoord[18].turnDir = "RIGHT" 
	t2EnemysCoord[18].turn	 = 180

	t2EnemysCoord[19].xaxis = 310
	t2EnemysCoord[19].yaxis = -540
	t2EnemysCoord[19].turnDir = "LEFT" 
	t2EnemysCoord[19].turn	 = 150	

	t2EnemysCoord[20].xaxis = 400
	t2EnemysCoord[20].yaxis = -100
	t2EnemysCoord[20].turnDir = "LEFT" 
	t2EnemysCoord[20].turn	 = 50	

	t2EnemysCoord[21].xaxis = 260
	t2EnemysCoord[21].yaxis = -180
	t2EnemysCoord[21].turnDir = "HARDRIGHT" 
	t2EnemysCoord[21].turn	 = 20	

	t2EnemysCoord[22].xaxis = 200
	t2EnemysCoord[22].yaxis = -160
	t2EnemysCoord[22].turnDir = "LEFT" 
	t2EnemysCoord[22].turn	 = 40

	t2EnemysCoord[23].xaxis = 140
	t2EnemysCoord[23].yaxis = -140
	t2EnemysCoord[23].turnDir = "HARDRIGHT" 
	t2EnemysCoord[23].turn	 = 60

	t2EnemysCoord[24].xaxis = 80
	t2EnemysCoord[24].yaxis = -120
	t2EnemysCoord[24].turnDir = "HARDRIGHT" 
	t2EnemysCoord[24].turn	 = 80

	t2EnemysCoord[25].xaxis = 20
	t2EnemysCoord[25].yaxis = -100
	t2EnemysCoord[25].turnDir = "HARDRIGHT" 
	t2EnemysCoord[25].turn	 = 100	
end

function createT2Enemys()

	if gameCounter == 0 then
		t2CreateActive = 1
	elseif gameCounter == 700 then
		t2CreateActive = 1
	elseif gameCounter == 1400 then
		t2CreateActive = 1
	elseif gameCounter == 2300 then
		t2CreateActive = 1
	elseif gameCounter == 3300 then
		t2CreateActive = 1
	elseif gameCounter == 4200 then
		t2CreateActive = 1
	elseif gameCounter == 4600 then
		t2CreateActive = 1
	elseif gameCounter == 5100 then
		t2CreateActive = 1
	elseif gameCounter == 5600 then
		t2CreateActive = 1
	elseif gameCounter == 6300 then
		t2CreateActive = 1
	elseif gameCounter == 6900 then
		t2CreateActive = 1
	elseif gameCounter == 7400 then
		t2CreateActive = 1
	elseif gameCounter == 7900 then
		t2CreateActive = 1
	elseif gameCounter == 8300 then
		t2CreateActive = 1
	elseif gameCounter == 8800 then
		t2CreateActive = 1
	elseif gameCounter == 8800 then
		t2CreateActive = 1
	elseif gameCounter == 9300 then
		t2CreateActive = 1
	elseif gameCounter == 9700 then
		t2CreateActive = 1
	elseif gameCounter == 10100 then
		t2CreateActive = 1
	elseif gameCounter == 10500 then
		t2CreateActive = 1
	elseif gameCounter == 10700 then
		t2CreateActive = 1

	end

	if t2CreateActive == 1 then
		setT2StartCoord()	
		for i = 1, 5 do	
			t2Enemys[i] = {}
			t2Enemys[i].xaxis = t2EnemysCoord[t2Wave].xaxis
			t2Enemys[i].yaxis = t2EnemysCoord[t2Wave].yaxis
			t2Enemys[i].dir	  = t2EnemysDir
			t2Enemys[i].turnDir = t2EnemysCoord[i].turnDir
			t2Enemys[i].turn    = t2EnemysCoord[i].turn
			t2Wave = t2Wave + 1
			t2Enemys[i].state = 1
			t2EnemyXstart = t2EnemyXstart + 50
			t2EnemyYstart = t2EnemyYstart + 40
			t2EnemysActive = 1
			totalEnemies = totalEnemies + 1

		end
		levelLoop = levelLoop + 1
	end

	if t2Wave >= maxT2Wave then
		t2Wave = 1
	end
	
	t2EnemyXstart = 150
	t2EnemyYstart = -240
	t2CreateActive = 0
end

function readControl()

	pad = Controls.read()

	if pad:left() then
		px = px - planeSpeed
		
		if px < 0 then
			px = 0
		end
	end

	if pad:right() then
		px = px + planeSpeed

		if px > 480 - planeWidth then
			px = 480 - planeWidth
		end
	end

	if pad:down() then
		py = py + planeSpeed

		if py > 272 - planeHeight then
			py = 272 - planeHeight
		end
	end

	if pad:up() then
		py = py - planeSpeed

		if py < 0 then
			py = 0
		end
	end

	if pad:cross() then
		playerShoot()
	end


	if pad:start() then
	 	gamePaused = 1
	end		

	while gamePaused == 1 do


--		batteryLife = System.powerGetBatteryLifePercent()
--		batteryTime = System.powerGetBatteryLifeTime()
--		systemTemp  = System.powerGetBatteryTemp()

		screen:clear()
		screen:blit(0, 0, selectBg)
		screen:print(197, 110, "P A U S E D", white)
		screen:print(150, 130, "press cross to continue", green)
--		screen:print(197, 140, "Battery Life: " ..batteryLife " / " .. batteryTime "Temperature: " ..systemTemp, red)

		screen.waitVblankStart()
		screen:flip()

		pad = Controls.read() 

		if pad:cross() then
			gamePaused = 0
		end
	end 	
end

function playerShoot()
		
	shotsFired = shotsFired + 1
	fireX = px + (planeWidth/2)
	fireY = py + 6
	planeShootActive = 1		

	if planeUsed == "A10" then
		addPlayerFireA(fireX-7, fireY)
	elseif planeUsed == "STEALTH" then
		addPlayerFireB(fireX-2, fireY)
	end

end
	

function shotFired()
	
	if planeShootActive == 1 then
--		fireY = fireY - 7
		if planeUsed == "A10" then
--			addPlayerFireA(fireX-7, fireY)
--			screen:blit(fireX-7, fireY, a10Shoot)
		elseif planeUsed == "STEALTH" then
--			screen:blit(fireX, fireY, planeShoot)	
		end

		if fireY < -7 then
			planeShootActive = 0
		end
	end
	
end

function shotCollision()
	
	if planeUsed == "A10" then
		fireWidth = a10Shoot:width()
		fireHeight = a10Shoot:height()
	elseif planeUsed == "STEALTH" then
		fireWidth = planeShoot:width()
		fireHeight = planeShoot:height()
	end

	for i = 1, 5 do
		if t1Enemys[i].state == 1 then
			for j = 1, maxPlayerFireA do
				if playerFireA[j].state == 1 then
				if ( (playerFireA[j].xaxis+fireWidth) > t1Enemys[i].xaxis)
				and playerFireA[j].xaxis < ( (t1Enemys[i].xaxis+enemy1:width()) ) then													if ( (playerFireA[j].yaxis+fireHeight) > t1Enemys[i].yaxis) 
				   	and ( playerFireA[j].yaxis < (t1Enemys[i].yaxis+enemy1:height()) ) then													addExplosions(t1Enemys[i].xaxis-(enemy1:width()/2), t1Enemys[i].yaxis-enemy1:height())
						score = score + 10
						t1Enemys[i].state = 0
						planeShootActive = 0
						planesHit = planesHit + 1
						playerFireA[j].state = 0
						playerFireAdelay = maxFireAdelay
					end
				end
				end
			end
		end
	end	

	for i = 1, 5 do
		if t2Enemys[i].state == 1 then
			for j = 1, maxPlayerFireA do
				if playerFireA[j].state == 1 then
				if ( (playerFireA[j].xaxis+fireWidth) > t2Enemys[i].xaxis)
				and playerFireA[j].xaxis < ( (t2Enemys[i].xaxis+enemy2:width()) ) then													if ( (playerFireA[j].yaxis+fireHeight) > t2Enemys[i].yaxis) 
				   	and ( playerFireA[j].yaxis < (t2Enemys[i].yaxis+enemy2:height()) ) then													addExplosions(t2Enemys[i].xaxis-(enemy2:width()/2), t2Enemys[i].yaxis-enemy2:height())
						score = score + 10
						t2Enemys[i].state = 0
						planeShootActive = 0
						planesHit = planesHit + 1
						playerFireA[j].state = 0
						playerFireAdelay = maxFireAdelay
					end
				end
				end
			end
		end
	end	


	if bomberActive == 1 then
		for j = 1, maxPlayerFireA do
			if playerFireA[j].state == 1 then
				if ( (playerFireA[j].xaxis+fireWidth) > bomberX)
				and playerFireA[j].xaxis < ( (bomberX+bomber:width()) ) then														if ( (playerFireA[j].yaxis+fireHeight) > bomberY) 
				   	and ( playerFireA[j].yaxis < (bomberY+bomber:height())-50 ) then														addExplosions(bomberX-(bomber:width()/2), bomberY-bomber:height())
					score = score + 20
					bomberHits = bomberHits - 1
					playerFireA[j].state = 0
					screen:blit(playerFireA[j].xaxis-(fireWidth/2), playerFireA[j].yaxis-streak:height(), streak)
					if bomberHits <= 0 then
						bomberActive = 0
						bomberHits = 45
						bomberExplodes()				
					end
					playerFireAdelay = maxFireAdelay
					planeShootActive = 0

				end
			end
			end
		end
	end

	for i = 1, 5 do
		if t1Enemys[i].state == 1 then
			for j = 1, maxPlayerFireB do
			if playerFireB[j].state == 1 then
				if ( (playerFireB[j].xaxis+fireWidth) > t1Enemys[i].xaxis)
				and playerFireB[j].xaxis < ( (t1Enemys[i].xaxis+enemy1:width()) ) then													if ( (playerFireB[j].yaxis+fireHeight) > t1Enemys[i].yaxis) 
				   	and ( playerFireB[j].yaxis < (t1Enemys[i].yaxis+enemy1:height()) ) then													addExplosions(t1Enemys[i].xaxis-(enemy1:width()/2), t1Enemys[i].yaxis-enemy1:height())
						score = score + 10
						t1Enemys[i].state = 0
						planeShootActive = 0
						planesHit = planesHit + 1
						playerFireB[j].state = 0
						playerFireBdelay = maxFireBdelay
					end
				end
			end
			end
		end
	end	

	for i = 1, 5 do
		if t2Enemys[i].state == 1 then
			for j = 1, maxPlayerFireB do
			if playerFireB[j].state == 1 then
				if ( (playerFireB[j].xaxis+fireWidth) > t2Enemys[i].xaxis)
				and playerFireB[j].xaxis < ( (t2Enemys[i].xaxis+enemy2:width()) ) then													if ( (playerFireB[j].yaxis+fireHeight) > t2Enemys[i].yaxis) 
				   	and ( playerFireB[j].yaxis < (t2Enemys[i].yaxis+enemy2:height()) ) then													addExplosions(t2Enemys[i].xaxis-(enemy2:width()/2), t2Enemys[i].yaxis-enemy2:height())
						score = score + 10
						t2Enemys[i].state = 0
						planeShootActive = 0
						planesHit = planesHit + 1
						playerFireB[j].state = 0
						playerFireBdelay = maxFireBdelay
					end
				end
			end
			end
		end
	end	


	if bomberActive == 1 then
		for j = 1, maxPlayerFireB do
			if playerFireB[j].state == 1 then
			if ( (playerFireB[j].xaxis+fireWidth) > bomberX)
			and playerFireB[j].xaxis < ( (bomberX+bomber:width()) ) then													if ( (playerFireB[j].yaxis+fireHeight) > bomberY) 
		   	and ( playerFireB[j].yaxis < (bomberY+bomber:height()-50) ) then													addExplosions(bomberX-(bomber:width()/2), bomberY-bomber:height())
					score = score + 20
					bomberHits = bomberHits - 1
					playerFireB[j].state = 0
					screen:blit(playerFireB[j].xaxis-(fireWidth/2), playerFireB[j].yaxis-streak:height(), streak)
					if bomberHits <= 0 then
						bomberActive = 0
						bomberHits = 45
						bomberExplodes()				
					end
					planeShootActive = 0
					playerFireBdelay = maxFireBdelay

				end
			end
			end
		end
	end

end

function planeCollision()

	if planeReset == 0 then
		for i = 1, 5 do
			if t1Enemys[i].state == 1 then       
				if  ( (px+(planeWidth+3) >= t1Enemys[i].xaxis) and ((px+3) <= t1Enemys[i].xaxis+enemy1:width()) ) then									if ( (py+(planeHeight-3) >= t1Enemys[i].yaxis) and ((py+3) <= t1Enemys[i].yaxis+enemy1:height()) ) then									--bang:play()
						bang:play()
						t1Enemys[i].state = 0
						addExplosions(t1Enemys[i].xaxis, t1Enemys[i].yaxis)
						addExplosions(px, py)
						playerLives = playerLives - 1
						resetPlayer()
						isGameOver()
					end
				end
			end

			if t2Enemys[i].state == 1 then       
				if  ( (px+(planeWidth+3) >= t2Enemys[i].xaxis) and ((px+3) <= t2Enemys[i].xaxis+enemy2:width()) ) then									if ( (py+(planeHeight-3) >= t2Enemys[i].yaxis) and ((py+3) <= t2Enemys[i].yaxis+enemy2:height()) ) then									--bang:play()
						bang:play()
						t2Enemys[i].state = 0
						addExplosions(t2Enemys[i].xaxis, t2Enemys[i].yaxis)
						addExplosions(px, py)
						playerLives = playerLives - 1
						resetPlayer()
						isGameOver()
					end
				end
			end
			if bomberActive == 1 then       
				if  ( (px+(planeWidth+3) >= bomberX) and ((px+3) <= bomberX+bomber:width()) ) then									if ( (py+(planeHeight-3) >= (bomberY/2)) and ((py+3) <= bomberY+(bomber:height()/2)) ) then												--bang:play()
						bang:play()
						bomberHits = bomberHits - 5	
						addExplosions(px, py)
						playerLives = playerLives - 1
						resetPlayer()
						isGameOver()
						if bomberHits <= 0 then
							addExplosions(bomberX, bomberY)
							addExplosions(bomberX+30, bomberY+30)
							bomberActive = 0
							bomberHits = 45
							bomberExplodes()
						end

					end
				end
			end
		end
	end
end

function bomberExplodes()

	for j=1, 300 do
		scrollBG()

		screen:blit(bomberX, bomberY, bomber)

		if j == 10 then
			addExplosions(bomberX, bomberY)
			addExplosions(bomberX+40, bomberY+5)
		elseif j == 20 then
			addExplosions(bomberX-10, bomberY+10)
			addExplosions(bomberX-5, bomberY+20)
		elseif j == 40 then
			addExplosions(bomberX-30, bomberY-10)
			addExplosions(bomberX-5, bomberY+20)
			addExplosions(bomberX+20, bomberY+10)
		elseif j == 60 then
			addExplosions(bomberX+60, bomberY-40)
			addExplosions(bomberX+5, bomberY-5)
		elseif j == 80 then
			addExplosions(bomberX, bomberY)
			addExplosions(bomberX+40, bomberY+5)
		elseif j == 100 then
			addExplosions(bomberX-10, bomberY+15)
			addExplosions(bomberX-20, bomberY+30)
		elseif j == 120 then
			addExplosions(bomberX-20, bomberY-10)
			addExplosions(bomberX-5, bomberY+20)
			addExplosions(bomberX+35, bomberY+10)
		elseif j == 150 then
			addExplosions(bomberX+40, bomberY-40)
			addExplosions(bomberX+5, bomberY-5)
		elseif j == 200 then
			addExplosions(bomberX, bomberY)
			addExplosions(bomberX+40, bomberY+5)
		elseif j == 220 then
			addExplosions(bomberX-10, bomberY+15)
			addExplosions(bomberX-20, bomberY+30)
		elseif j == 240 then
			addExplosions(bomberX-20, bomberY-10)
			addExplosions(bomberX-5, bomberY+20)
			addExplosions(bomberX+35, bomberY+10)
		elseif j == 280 then
			addExplosions(bomberX+40, bomberY-40)
			addExplosions(bomberX+5, bomberY-5)
			addExplosions(bomberX-20, bomberY-10)
			addExplosions(bomberX-5, bomberY+20)
			addExplosions(bomberX+55, bomberY+60)
			addExplosions(bomberX+30, bomberY+10)
			addExplosions(bomberX+45, bomberY+30)
		end
		drawExplosions()
		gameCounter = gameCounter + 1
		displayScore()
		drawLivesLeft()
		screen.waitVblankStart()
 		screen:flip()
	end

end


function drawPlane()

	if planeUsed == "A10" then
		screen:blit(px, py, a10Img)
		planeWidth = a10Img:width()
		planeHeight = a10Img:height()
	elseif planeUsed == "STEALTH" then
		screen:blit(px, py, stealthImg)
		planeWidth = stealthImg:width()
		planeHeight = stealthImg:height()
	end
end

function drawLivesLeft()

	if playerLives == 3 then
		screen:blit(22, 3, planeSmall)
		screen:blit(35, 3, planeSmall)
		screen:blit(48, 3, planeSmall)
	elseif playerLives == 2 then
		screen:blit(35, 3, planeSmall)
		screen:blit(48, 3, planeSmall)
	elseif playerLives == 1 then
		screen:blit(48, 3, planeSmall)
		
	end
end

function isGameOver()

	if playerLives == 0 then
--		gamePlaying = 0
		gameOver = 1
	end

end

function setGameDefaults()

	if planeUsed == "A10" then
		planeSpeed = a10Speed
	elseif planeUsed == "STEALTH" then
		planeSpeed = stealthSpeed
	end
	playerLives = 3
	level = 1
	score = 0
	t1EnemysActive = 0
	t2EnemysActive = 0
	resetPlayer()
	showTitle = 1
	showPlaneSelect = 1
	gameCounter = 0
	shotsFired	= 0
	planesHit	= 0
	totalEnemies	= 0
	t2Wave		= 1
	t1Wave		= 1
	backgroundY 	= 0
	bgIndex 	= 1
	nextBGIndex	= 2

	
end

function resetPlayer()

	px = 230
	py = 220
	planeReset = 1

end

function playerReset()

	if planeReset == 1 then
		if planeUsed == "STEALTH" then
			if resetCount > 0 and resetCount <= 10 then
				stealthImg = stealthDark
			elseif resetCount > 10 and resetCount <= 20 then
				stealthImg = stealthBright
			elseif resetCount > 20 and resetCount <= 30 then
				stealthImg = stealthDark
			elseif resetCount > 30 and resetCount <= 40 then
				stealthImg = stealthBright
			elseif resetCount > 40 and resetCount <= 50 then
				stealthImg = stealthDark
			elseif resetCount > 50 and resetCount <= 60 then
				stealthImg = stealthBright
			elseif resetCount > 60 and resetCount <= 70 then
				stealthImg = stealthDark
			elseif resetCount > 70 and resetCount <= 80 then
				stealthImg = stealthBright
			elseif resetCount > 80 and resetCount <= 90 then
				stealthImg = stealthDark
			elseif resetCount > 100 then
				planeReset = 0
				resetCount = 1
			end
		end
		if planeUsed == "A10" then
			if resetCount > 0 and resetCount <= 10 then
				a10Img = a10Dark
			elseif resetCount > 10 and resetCount <= 20 then
				a10Img = a10Bright
			elseif resetCount > 20 and resetCount <= 30 then
				a10Img = a10Dark
			elseif resetCount > 30 and resetCount <= 40 then
				a10Img = a10Bright
			elseif resetCount > 40 and resetCount <= 50 then
				a10Img = a10Dark
			elseif resetCount > 50 and resetCount <= 60 then
				a10Img = a10Bright
			elseif resetCount > 60 and resetCount <= 70 then
				a10Img = a10Dark
			elseif resetCount > 70 and resetCount <= 80 then
				a10Img = a10Bright
			elseif resetCount > 80 and resetCount <= 90 then
				a10Img = a10Dark
			elseif resetCount > 100 then
				planeReset = 0
				resetCount = 1
			end
		end

	resetCount = resetCount + 1
	end
			
end

function loadBg()

background = {}

		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 10%", green)
		screen.waitVblankStart()
		screen:flip()


		background1  	= Image.load('images/bg' ..level.. '/bg1.png')
		background[1] = background1
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 20%", green)
		screen.waitVblankStart()
		screen:flip()

		background2 	= Image.load('images/bg' ..level.. '/bg2.png')
		background[2] = background2
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 30%", green)
		screen.waitVblankStart()
		screen:flip()


		background3 	= Image.load('images/bg' ..level.. '/bg3.png')
		background[3] = background3
		allSys:play()
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 40%", green)
		screen.waitVblankStart()
		screen:flip()


		background4 	= Image.load('images/bg' ..level.. '/bg4.png')
		background[4] = background4
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 50%", green)
		screen.waitVblankStart()
		screen:flip()


		background5 	= Image.load('images/bg' ..level.. '/bg5.png')
		background[5] = background5
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 60%", green)
		screen.waitVblankStart()
		screen:flip()


		background6 	= Image.load('images/bg' ..level.. '/bg6.png')
		background[6] = background6
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 70%", green)
		screen.waitVblankStart()
		screen:flip()


		background7 	= Image.load('images/bg' ..level.. '/bg7.png')
		background[7] = background7
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 80%", green)
		screen.waitVblankStart()
		screen:flip()


		background8 	= Image.load('images/bg' ..level.. '/bg8.png')
		background[8] = background8
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 90%", green)
		screen.waitVblankStart()
		screen:flip()


		background9 	= Image.load('images/bg' ..level.. '/bg9.png')
		background[9] = background9
		screen:clear()
		screen:print(170,100, "   L E V E L  " .. level, green) 
		screen:print(170,120, "L O A D I N G - 100%", green)
		screen.waitVblankStart()
		screen:flip()

		background10 	= Image.load('images/bg' ..level.. '/bg10.png')
		background[10] = background10
end


function scrollBG()

	backgroundY = backgroundY + .5
	if backgroundY > 272 then
		if nextBGIndex == 1 then
			bgIndex = 0
		end

		backgroundY = 0

		bgIndex = bgIndex + 1
		nextBGIndex = nextBGIndex + 1

	end	

	if bgIndex >= 10 then
		nextBGIndex = 1
		bgIndex = 10
	end

	screen:blit(0, backgroundY, background[bgIndex])
	screen:blit(0, backgroundY-272, background[nextBGIndex])
end

function levelChange()

	levelPause = 1

	if bomberActive == 0 and gameCounter >= 8100 then
		while levelPause == 1 do
			hitPercent = (planesHit/shotsFired) * 100
			destroyPercent = (planesHit/totalEnemies) * 100
			screen:clear()
			screen:blit(0, 0, selectBg)
			screen:print(120, 50,  "S T A G E  " ..level.. "   C O M P L E T E!", green)
			screen:print(135, 70,  "SHOTS FIRED         " ..shotsFired, white)
			screen:print(135, 80,  "TOTAL ENEMIES       " ..totalEnemies, white)
			screen:print(135, 90,  "SHOTS HIT           " ..planesHit, white)
			screen:print(135, 100, "HIT PERCENTAGE      " ..hitPercent.. "%", white)
			screen:print(135, 110, "PLANES DESTROYED    " ..destroyPercent.. "%", white)

			screen:print(120, 150, "press circle for next stage", green)		
			screen.waitVblankStart()
			screen:flip()

			pad = Controls.read()

			if pad:circle() then
				levelPause = 0
			end
		end

		if level == 1 then
			level = 2
		elseif level == 2 then
			level = 3
		elseif level == 3 then
			level = 4
		elseif level == 4 then
			level = 1
		end	

		levelLoop = 1
		loadBg()
		gameCounter = 0
		shotsFired = 0
		planesHit = 0
		totalEnemies = 0
		setT1StartCoord()
		setT2StartCoord()
	end
end


function scrollT1Enemys()

	t1EnemysActive = 0
	t2EnemysActive = 0

	for i = 1, 5 do
		if t1Enemys[i].state == 1 then
			t1Enemys[i].yaxis = t1Enemys[i].yaxis + t1EnemysSpeed
			t1EnemysActive = 1
			screen:blit(t1Enemys[i].xaxis, t1Enemys[i].yaxis, enemy1)
		end

		if t1Enemys[i].yaxis > 272 then
			t1Enemys[i].state = 0
		end
		
		if t2Enemys[i].state == 1 then
			if t2Enemys[i].dir == "DOWN" then
				t2Enemys[i].yaxis = t2Enemys[i].yaxis + t2EnemysSpeed
				t2EnemysActive = 1
				screen:blit(t2Enemys[i].xaxis, t2Enemys[i].yaxis, enemy2)

				if t2Enemys[i].yaxis >= t2Enemys[i].turn then
					if t2Enemys[i].turnDir == "RIGHT" then
						t2Enemys[i].dir = "DOWNRIGHT"
					elseif t2Enemys[i].turnDir == "LEFT" then
						t2Enemys[i].dir = "DOWNLEFT"
					elseif t2Enemys[i].turnDir == "HARDLEFT" then
						t2Enemys[i].dir = "LEFT"
					elseif t2Enemys[i].turnDir == "HARDRIGHT" then
						t2Enemys[i].dir = "RIGHT" 
					end
				end
			elseif t2Enemys[i].dir == "RIGHT" then
				t2Enemys[i].xaxis = t2Enemys[i].xaxis + t2EnemysSpeed
				t2EnemysActive = 1
				screen:blit(t2Enemys[i].xaxis, t2Enemys[i].yaxis, enemy2R)
			elseif t2Enemys[i].dir == "LEFT" then
				t2Enemys[i].xaxis = t2Enemys[i].xaxis - t2EnemysSpeed
				t2EnemysActive = 1
				screen:blit(t2Enemys[i].xaxis, t2Enemys[i].yaxis, enemy2L)
			elseif t2Enemys[i].dir == "DOWNRIGHT" then
				t2Enemys[i].xaxis = t2Enemys[i].xaxis + t2EnemysSpeed
				t2Enemys[i].yaxis = t2Enemys[i].yaxis + t2EnemysSpeed
				t2EnemysActive = 1
				screen:blit(t2Enemys[i].xaxis, t2Enemys[i].yaxis, enemy2DR)
			elseif t2Enemys[i].dir == "DOWNLEFT" then
				t2Enemys[i].xaxis = t2Enemys[i].xaxis - t2EnemysSpeed
				t2Enemys[i].yaxis = t2Enemys[i].yaxis + t2EnemysSpeed
				t2EnemysActive = 1
				screen:blit(t2Enemys[i].xaxis, t2Enemys[i].yaxis, enemy2DL)
			end								
		end

		if t2Enemys[i].yaxis > 272 or t2Enemys[i].xaxis > 480 or t2Enemys[i].xaxis < 0 - enemy2DL:width() then
			t2Enemys[i].state = 0
		end

	end

	if bomberActive == 1 then
		if bomberY < 10 then		
			bomberY = bomberY + bomberSpeed
		end

		if bomberDirection == "LEFT" then
			if bomberX <= 30 then
				bomberDirection = "RIGHT"
			elseif bomberX > 30 then
				bomberX = bomberX - .6
			end
		end		
		if bomberDirection == "RIGHT" then
			if bomberX >= 380 then
				bomberDirection = "LEFT"
			elseif bomberX < 450 then
				bomberX = bomberX + .6
			end
		end

		screen:blit(bomberX, bomberY, bomber)
	end 

end

function displayScore()

	screen:print(5, 3, "1P", red)
	screen:print(5, 12, score, white)
	screen:print(200, 3, "HIGH SCORE", red)
	screen:print(200, 12, highScore, white)

end


--***********************************************************
-- main
--
--
--***********************************************************
titleShow()

while gamePlaying == 1 do

	selectShow()

	setGameDefaults()
	loadBg()
	bgMusic = Sound.load("sounds/bgmusic2.wav", true)
	bgMusic:play()

	while gameOver == 0 do
		scrollBG()
--		screen:print(400, 5, gameCounter, red)
		drawLivesLeft()
		shotFired()
		drawPlane()
		createT1Enemys()
		createT2Enemys()
		createBomber()
		displayScore()
		readControl()
		scrollT1Enemys()
		shotCollision()
		planeCollision()
		drawExplosions()
		drawPlayerFireA()
		drawPlayerFireB()
		playerReset()
		levelChange()
		screen.waitVblankStart()
		screen:flip()
		gameCounter = gameCounter + 1
	end	

	
	bgMusic = nil
	while gameOver == 1 do
		pad = Controls.read()

		if pad:triangle() then
			gamePlaying = 0
			gameOver = 0
		end		

		if pad:circle() then
			gameOver = 0
		end

		screen:clear()
		screen:print(180,120, "G A M E  O V E R", green)

		screen:print(145,140, "press circle to continue", white)
		screen:print(160,160, "press triange to quit", white)
		screen.waitVblankStart()
		screen:flip()
	end

	if score > highScore then
		highScore = score
	end
end
